<?php

/**
 * 
 * 
 * 
 * 
 * 
 * 
 */

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
if (!is_object($vbulletin->db))
{
	exit;
}

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('ONEDAY', 86400);

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################


if($vbulletin->options['reminder_enabled'])
{

    // Checked in plugin to determine who is requesting HTML Email
    // to be sent.
    $_SESSION['CRONTASK_REMINDEREMAILS'] = 1; 

    $webmaster_email = $vbulletin->options['webmasteremail'];
    
    //$domain =  strrchr($webmaster_email, '@');
    
	$batchLimit = $vbulletin->options['reminder_batch'];

	$reminder_maxemail = $vbulletin->options['reminder_maxemails'];

    if ($vbulletin->options['reminder_inactivitygraceperiod'] > 0)
    {
        $inactivity_graceperiodDays = $vbulletin->options['reminder_inactivitygraceperiod'];   
    	$inactivity_graceperiod = TIMENOW - ($inactivity_graceperiodDays * ONEDAY);
    }
    else
    {
		print_cp_message( 'How many days can a user go before they are considered inactive?<br/> 
                           Please enter a number greater than zero.', 'options.php?do=options&dogroup=remindermail', 5 );
    }
    
    if ($vbulletin->options['reminder_frequency'] > 0)
    {
        $reminder_frequencyDays = $vbulletin->options['reminder_frequency'];
    	$lastemail = TIMENOW - ($reminder_frequencyDays * ONEDAY);
        $nextemail = TIMENOW + ($reminder_frequencyDays * ONEDAY);
        $nextemaildate = vbdate( $vbulletin->options['dateformat'], $nextemail);
    }
    else
    {
		print_cp_message( 'How often should we send inactivity reminders to inactive members?\n 
                           Please enter a number greater than zero.', 'options.php?do=options&dogroup=remindermail', 5 );
    }

	// Returns a single quote comma-delimited list of usergroup ids
	if ( !IsNullOrEmptyString( $vbulletin->options['reminder_usergroups'] ) )
	{
        $usergroups = str_replace(",","','", trim($vbulletin->options['reminder_usergroups']));
	}
	else
	{
		print_cp_message( 'Please enter one or more usergroups to monitor', 
                                    'options.php?do=options&dogroup=remindermail', 5 );
	}

	// Returns a single quote comma-delimited list of userids that should be excluded
	// from reminder emails.
  	if ( !IsNullOrEmptyString( $vbulletin->options['reminder_excludeduserids'] ) )
	{
        $excludeduserids = str_replace(",","','", trim($vbulletin->options['reminder_excludeduserids']) );
    }    
	
    print("Looking for inactive users...<br/><br/>");
	
	// How many emails to send to each inactive user per
	// inactive period. (0 for unlimited)    
	if($vbulletin->options['reminder_sendonce'])
    {

        // Are we sending reminders based on last post date?        
		if($vbulletin->options['reminder_posts'])
        {

       		print("Basing reminders on Last Post Date...<br/><br/>");

			$sql = "SELECT * 
					FROM " . TABLE_PREFIX . "user 
					WHERE lastpost < '$inactivity_graceperiod' AND 
					emailDate < '$lastemail' AND 
					emailCount = '0' AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";

			if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "')"; 

            if (intval($batchLimit) > 0) $sql .= "LIMIT 0, " . $batchLimit . "";

			$result = $vbulletin->db->query_read($sql);
			//print($sql."<br/><br/>");

            print( $vbulletin->db->num_rows( $result ) . " inactive user(s) found!<br/><br/>");

			if ( $vbulletin->db->num_rows( $result ) != 0 )
			{

				$sql = "UPDATE " . TABLE_PREFIX . "user 
						SET emailDate = '".TIMENOW."', 
						emailCount = '1' 
						WHERE lastpost < '$inactivity_graceperiod' AND 
						emailDate < '$lastemail' AND 
						emailCount = '0' AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";

				if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "')"; 
                if (intval($batchLimit) > 0) $sql .= "LIMIT " . $batchLimit . "";
						
				$vbulletin->db->query_write($sql);
				//print($sql."<br/><br/>");

        		print("Reminders will be sent once to the following users: <br/><br/>");

			}

		} 
        else /****** Let's send reminders once based on the users last activity date. ******/ 
        {
       		print("Basing reminders on Last Activity Date...<br/><br/>");

			$sql = "SELECT * 
					FROM " . TABLE_PREFIX . "user 
					WHERE lastactivity < '$inactivity_graceperiod' AND 
					emailDate < '$lastemail' AND 
					emailCount = '0' AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";

			if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "')"; 
            if (intval($batchLimit) > 0) $sql .= "LIMIT 0, " . $batchLimit . "";
				
			$result = $vbulletin->db->query_read($sql);
			//print($sql."<br/><br/>");

            print( $vbulletin->db->num_rows( $result ) . " inactive user(s) found!<br/><br/>");

			if ( $vbulletin->db->num_rows( $result ) != 0 )
			{
			
				$sql = 	"UPDATE " . TABLE_PREFIX . "user 
						SET emailDate = '".TIMENOW."', 
						emailCount = '1' 
						WHERE lastactivity < '$inactivity_graceperiod' AND 
						emailDate < '$lastemail' AND 
						emailCount = '0' AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";

				if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "')"; 
                if (intval($batchLimit) > 0) $sql .= "LIMIT " . $batchLimit . "";
						
				$vbulletin->db->query_write($sql);
				//print($sql."<br/><br/>");

        		print("Reminders will be sent once to the following users: <br/><br/>");
			
			}
		}
        
	} 
    else   
    {
        /****** Are we sending reminders based on last post date? ******/
		if($vbulletin->options['reminder_posts'])
        {
       		print("Basing reminders on Last Post Date...<br/><br/>");

			$sql = "SELECT * FROM " . TABLE_PREFIX . "user 
                    WHERE lastpost < '$inactivity_graceperiod' AND 
                    emailDate < '$lastemail' "; 

            // Do we want to set a maximum limit? 
            if (intval($reminder_maxemail) > 0) $sql .= "AND emailCount < '$reminder_maxemail' "; 

            // Add a check to see if these users can receive emails from administrators                     
            $sql .= "AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";

            // Do we want to exclude specific users from getting reminders?
			if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "')"; 					

            // Now many users do we want to process during this job?
            if (intval($batchLimit) > 0) $sql .= "LIMIT 0, " . $batchLimit . "";

            // let's go get 'em!                    
			$result = $vbulletin->db->query_read($sql);
			//print($sql."<br/><br/>");

            print( $vbulletin->db->num_rows( $result ) . " inactive user(s) found!<br/><br/>");

			if ( $vbulletin->db->num_rows( $result ) != 0 )
            {		  

    			$sql = "UPDATE " . TABLE_PREFIX . "user SET emailDate = '".TIMENOW."'";
                
                if (intval($reminder_maxemail) > 0) $sql .= ", emailCount = emailCount + 1";
                
                $sql .= " WHERE lastpost < '$inactivity_graceperiod' AND emailDate < '$lastemail' ";
    
				$sql .= " WHERE lastactivity < '$inactivity_graceperiod' AND emailDate < '$lastemail' "; 
                
                if (intval($reminder_quantity) > 0) $sql .= "AND emailCount < '$reminder_maxemail' ";
                
                $sql .= "AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";
    
        		if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "') ";
                
                if (intval($batchLimit) > 0) $sql .= "LIMIT " . $batchLimit . "";
    					
    			$vbulletin->db->query_write($sql);
    			//print($sql."<br/><br/>");


                $msg = "On-going reminders will be sent to the following users every ". $reminder_frequencyDays ." days ";     

                if (intval($reminder_maxemail) > 0)
                {
                   $msg .= "up to a maximum of ".$reminder_maxemail.":<br/><br/>";
                }
        		print($msg);
        		print("<br/><br/>Inactivity reminders for these users will be sent out again on: ". $nextemaildate ." if they have not logged in or <br/>posted before then.<br/><br/>");

            }

		} 
        else 
        {

       		print("Basing reminders on Last Activity Date...<br/><br/>");

			$sql = "SELECT * FROM " . TABLE_PREFIX . "user 
                    WHERE lastactivity < '$inactivity_graceperiod' AND 
                    emailDate < '$lastemail' "; 
                    
            // Do we want to set a maximum limit? 
            if (intval($reminder_maxemail) > 0) $sql .= "AND emailCount < '$reminder_maxemail' "; 

            // Add a check to see if these users can receive emails from administrators                     
            $sql .= "AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";

			if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "')"; 

            if (intval($batchLimit) > 0) $sql .= "LIMIT 0, " . $batchLimit . "";
			
			$result = $vbulletin->db->query_read($sql);
			//print($sql."<br/><br/>");

            print( $vbulletin->db->num_rows( $result ) . " inactive user(s) found!<br/><br/>");

			if ( $vbulletin->db->num_rows( $result ) != 0 )
            {		  

    			$sql = "UPDATE " . TABLE_PREFIX . "user	SET emailDate = '".TIMENOW."'";
                
                if (intval($reminder_maxemail) > 0) $sql .= ", emailCount = emailCount + 1";
                
				$sql .= " WHERE lastactivity < '$inactivity_graceperiod' AND emailDate < '$lastemail' "; 
                
                if (intval($reminder_maxemail) > 0) $sql .= "AND emailCount < '$reminder_maxemail' ";
                
                $sql .= "AND options & 16 AND usergroupid IN ('" . $usergroups . "') ";
    
        		if (strlen($excludeduserids) > 0) $sql .= "AND userid NOT IN ('" . $excludeduserids . "') ";
                
                if (intval($batchLimit) > 0) $sql .= "LIMIT " . $batchLimit . "";
    				
    			$vbulletin->db->query_write($sql);
    			//print($sql."<br/><br/>");

                $msg = "On-going reminders will be sent to the following users every ". $reminder_frequencyDays ." days ";     

                if (intval($reminder_maxemail) > 0)
                {
                   $msg .= "up to a maximum of ". $reminder_maxemail .":<br/><br/>";
                }

        		print($msg);

        		print("<br/><br/>Inactivity reminders for these users will be sent out again on: ". $nextemaildate ." if they have not logged in or <br/>posted before then.<br/><br/>");

            }
		}
	}
    
	while($row = $vbulletin->db->fetch_array($result))
    {		
        
		print("Sent To: $row[username]<br/>");

		$userid = $row[userid];         // userid 
		$username = $row[username];     // username      
        $toemail = $row[email];         // user email address
        $email = $row[email];           // user email address   
        //$lastpost = $row[lastpost];     // lastpost timestamp
        //$lastactivity = $row[lastactivity];   // lastpost timestamp
        //$dayssincelastpost = GetDaysSinceLastPost($now, $lastpost);
        //$dayssincelastactivity = GetDaysSinceLastPost($now, $lastactivity);

		$bbtitle = $vbulletin->options['bbtitle'];
		$homeurl = $vbulletin->options['homeurl'];
		$forumurl = $vbulletin->options['bburl'];
		$hometitle = $vbulletin->options['hometitle'];
        
        // Return Path will be used in future versions when detecting bounced email.    
        //$return_path = "user-".((int)$userid)."-bounce" . $domain . "\r\n";

        // Are we sending reminders in html or plain text?            
        if (strtolower($vbulletin->options['reminder_emailformat'] == 'html'))
        {
            
        	$uheaders  = $return_path . "MIME-Version: 1.0" . "\r\nContent-type: text/html; charset=iso-8859-1" . "\r\n";
            eval(fetch_email_phrases('inactivity_reminder_html'));

            // Do we need to turn on the footer?
       		if($vbulletin->options['reminder_emailfooter'])
            {
                $emailfooter .= "<br/><br/>Email Reminder System Provided By <a href='http://www.talkvirginia.net/'>TalkVirginia</a><br/>
                                 Your source for chat, news and information on Virginia";
                $message = str_replace('</body>', $emailfooter.'</body>', $message);                 
            }
            
        }
        else
        {
        	$uheaders  = $return_path . "MIME-Version: 1.0" . "\r\nContent-type: text/plain; charset=iso-8859-1" . "\r\n";
            eval(fetch_email_phrases('inactivity_reminder_plaintext'));
            
       		if($vbulletin->options['reminder_emailfooter'])
            {
                $message .= "\r\n\r\n";
                $message .= "Email Reminder System Provided By http://www.talkvirginia.net\r\n";
                $message .= "Your source for chat, news and information on Virginia";
            }                        
        }
        
		$uheaders .= "To: $username <$email>\r\n";
		$uheaders .= "From: " . $vbulletin->options['bbtitle'] . " Reminder Service <" . $webmaster_email .">\r\n";

		if(is_valid_email($toemail))
        {				
            $valid = "1";
			$sentlist .= "$username ";
 			$this_username = "$username";
 
			if (vbmail($toemail, $subject, $message, $notsubscription = false, $from = $vbulletin->options['bbtitle'], $uheaders = '', $username = ''))
            {

            	if ( $vbulletin->options['reminder_logenabled'] )
            	{

            		$sql = "INSERT INTO " . TABLE_PREFIX . "inactiveuserlog (username,userid,dateline,validemail,email) 
                            VALUES ('$this_username','$userid','". TIMENOW ."','$valid','$toemail')";
            		$vbulletin->db->query_write( $sql );
            		//print("$sql<br />");
          			//print $vbulletin->db->affected_rows . "row(s) affected.";
            
            		if ( $vbulletin->options['reminder_logduration'] > 0 )
            		{
            			$deleteperiod = TIMENOW - ( $vbulletin->options['reminder_logduration'] * ONEDAY );
            			$sql = "DELETE FROM " . TABLE_PREFIX . "inactiveuserlog WHERE dateline < '$deleteperiod'";
            			$vbulletin->db->query_write( $sql );
            			//print $sql;
            			//print $vbulletin->db->affected_rows . "row(s) affected.";
            		}

            	}

            }
		} 
		else 
		{
            $valid = "0";

			$failedlist .= "$username ";

        	if ( $vbulletin->options['reminder_logenabled'] )
        	{

        		$sql = "INSERT INTO " . TABLE_PREFIX . "inactiveuserlog (username,userid,dateline,validemail,email) 
                        VALUES ('$username','$userid','". TIMENOW ."','$valid','$toemail')";
        		$vbulletin->db->query_write( $sql );
        		//print("$sql<br />");
      			//print $vbulletin->db->affected_rows . "row(s) affected.";
        
        		if ( $vbulletin->options['reminder_logduration'] > 0 )
        		{
        			$deleteperiod = TIMENOW - ( $vbulletin->options['reminder_logduration'] * ONEDAY );
        			$sql = "DELETE FROM " . TABLE_PREFIX . "inactiveuserlog WHERE dateline < '$deleteperiod'";
        			$vbulletin->db->query_write( $sql );
        			//print $sql;
        			//print $vbulletin->db->affected_rows . "row(s) affected.";
        		}

        	}

		}
		
	}


    /*
     * === Administrator Logging and Email Section ===
     */
	if($sentlist == "")
    {
        $uheaders = $uheaders = "From: " . $bbtitle . " Reminder Service <" . $vbulletin->options['webmasteremail'] . ">" . "\r\n";
        $toemail = $vbulletin->options['webmasteremail'];
        $sub = "Inactive User Reminder Email Report";
        $msg = "This email shows that the product is installed and working as it should be.\n\n\nThere were no inactive users at this time.";
        $msg = ($vbulletin->options['reminder_emailformat'] == 'html') ? str_replace("\n", "</br>", $msg) : $msg;
		log_cron_action("No Emails to send", $nextitem);
		vbmail($toemail, $sub,$msg, $notsubscription = false, $from = $bbtitle, $uheaders, $username = '');
	} 
    else 
    {
        $uheaders = "From: " . $bbtitle . " Reminder Service <" . $vbulletin->options['webmasteremail'] . ">" . "\r\n";
        $toemail = $vbulletin->options['webmasteremail'];
        $sub  = "Inactive User Reminder Email Report";
        $msg  =  "This email shows that the product is installed and working as it should be.\n\n\n";
        $msg .=  "Emails sent to:\r\n " . $sentlist . "\n\n\nWe tried to email the following users, but their email address was invalid:\r\n" . $failedlist . "";
        $msg = ($vbulletin->options['reminder_emailformat'] == 'html') ? str_replace("\n", "</br>", $msg) : $msg;

		log_cron_action("Emails sent to: $sentlist. We tried to email the following users, but their email address was invalid:\r\n" . $failedlist, $nextitem);
		vbmail($toemail, $sub, $msg, $notsubscription = false, $from = $bbtitle, $uheaders, $username = '');
	}

    
    $_SESSION['CRONTASK_REMINDEREMAILS'] = 0; 
} 
else 
{
	print("Product is inactive at this time!");
}

/******  Helper Functions ****************/

/**
 * IsNullOrEmptyString()
 * 
 * @param mixed $question
 * @return
 */
function IsNullOrEmptyString( $question )
{
    return ( !isset( $question ) || trim( $question ) === '' );
}

function GetDaysSinceLastPost($now, $lastpost)
{
    $diff = ($now - $lastpost);
    $days = ceil((($diff / 60) / 60) / 24);
    return $days;
}

function GetDaysSinceLastActivity($now, $lastpost)
{
    $diff = ($now - $lastactivity);
    $days = ceil((($diff / 60) / 60) / 24);
    return $days;
}

?>